package com.ruoyi.system.controller;

import org.apache.commons.lang3.tuple.Pair;
import java.util.stream.Collector;
import com.ruoyi.common.core.utils.bean.BeanUtils;
import com.ruoyi.system.domain.dto.SnServerTemplateDto;
import java.util.stream.Collectors;
import com.ruoyi.system.domain.SnTemplate;
import java.util.function.Function;
import com.ruoyi.system.domain.SnServerTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import com.ruoyi.system.api.domain.SysUser;
import java.util.List;
import java.util.Map;
import com.ruoyi.common.core.utils.JwtUtils;
import com.alibaba.fastjson2.JSONObject;
import java.util.HashMap;
import java.util.Date;
import java.util.Objects;
import com.ruoyi.system.domain.SnServer;
import com.ruoyi.common.core.utils.ip.IpUtils;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.PostMapping;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.web.domain.AjaxResult;
import org.springframework.web.bind.annotation.RequestBody;
import com.ruoyi.system.domain.SnCard;
import com.ruoyi.system.service.ISnServerTemplateService;
import com.ruoyi.system.service.ISysConfigService;
import com.ruoyi.system.service.ISnCardService;
import com.ruoyi.system.mapper.SnServerTemplateMapper;
import com.ruoyi.system.mapper.SnTemplateMapper;
import com.ruoyi.system.mapper.SnServerMapper;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.service.ISysUserService;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.core.web.controller.BaseController;

@RestController
@RequestMapping({ "/external" })
public class ExternalController extends BaseController
{
    @Autowired
    private ISysUserService sysUserService;
    @Autowired
    private SnServerMapper snServerMapper;
    @Autowired
    private SnTemplateMapper snTemplateMapper;
    @Autowired
    private SnServerTemplateMapper snServerTemplateMapper;
    @Autowired
    private ISnCardService snCardService;
    @Autowired
    private ISysConfigService configService;
    @Autowired
    private ISnServerTemplateService snServerTemplateService;
    
    @Log(title = "卡密充值", businessType = BusinessType.GRANT)
    @PostMapping({ "/charge" })
    public AjaxResult charge(@RequestBody final SnCard snCard) {
        if (snCard.getCode() == null) {
            return this.error("请输入卡密");
        }
        if (StringUtils.isEmpty(snCard.getUserName())) {
            return this.error("请输入商户账号");
        }
        if (StringUtils.isEmpty(snCard.getPassword())) {
            return this.error("请输入商户密码");
        }
        return this.snCardService.charge(snCard);
    }
    
    @GetMapping({ "/license" })
    public AjaxResult license(@RequestParam("code") final String code) {
        String ip = IpUtils.getIpAddr();
        if (ip.equals("127.0.0.1")) {
            ip = "43.130.6.19";
        }
        final SnServer params = new SnServer();
        params.setIp(ip);
        params.setIsDelete(Integer.valueOf(0));
        final List<SnServer> servers = this.snServerMapper.selectSnServerList(params);
        if (servers.isEmpty()) {
            return this.error("该服务器IP未获得授权");
        }
        final SnServer server = servers.get(0);
        if (server.getStatus() != 2) {
            return this.error("该服务器状态异常");
        }
        final SysUser user = this.sysUserService.selectUserById(server.getCreateId());
        if (!Objects.equals(user.getLicense(), code)) {
            return this.error("授权码有误");
        }
        if (user.getPeriod() == null || user.getPeriod().before(new Date())) {
            return this.error("此商户已超过使用期限");
        }
        final Map<String, Object> claimsMap = new HashMap<String, Object>();
        claimsMap.put("serverIp", server.getIp());
        return AjaxResult.success("获取成功", (Object)new JSONObject().fluentPut("token", (Object)JwtUtils.createToken((Map)claimsMap)).fluentPut("period", (Object)((user.getPeriod() != null) ? user.getPeriod().getTime() : 0L)));
    }
    
    @GetMapping({ "/clientList" })
    public AjaxResult clientList(@RequestParam("code") final String code) {
        String ip = IpUtils.getIpAddr();
        if (ip.equals("127.0.0.1")) {
            ip = "43.130.6.19";
        }
        final SnServer params = new SnServer();
        params.setIp(ip);
        params.setIsDelete(Integer.valueOf(0));
        final List<SnServer> servers = this.snServerMapper.selectSnServerList(params);
        if (servers.isEmpty()) {
            return this.error("该服务器IP未获得授权");
        }
        final SnServer server = servers.get(0);
        if (server.getStatus() != 2) {
            return this.error("该服务器状态异常");
        }
        final SysUser user = this.sysUserService.selectUserById(server.getCreateId());
        if (!Objects.equals(user.getLicense(), code)) {
            return this.error("授权码有误");
        }
        if (user.getPeriod().before(new Date())) {
            return this.error("此商户已超过使用期限");
        }
        final SnServerTemplate query = new SnServerTemplate();
        query.setServerId(server.getServerId());
        query.setIsDelete(Integer.valueOf(0));
        final List<SnServerTemplate> list = this.snServerTemplateMapper.selectSnServerTemplateList(query);
        final Long[] templateIds = list.stream().map((Function<? super Object, ?>)SnServerTemplate::getTemplateId).distinct().toArray(Long[]::new);
        final SnTemplate snTemplate = new SnTemplate();
        snTemplate.getParams().put("excludeBack", 1);
        snTemplate.getParams().put("templateIds", templateIds);
        final List<SnTemplate> tempList = this.snTemplateMapper.selectSnTemplateList(snTemplate);
        final Map<Long, SnTemplate> tempMap = tempList.stream().collect(Collectors.toMap((Function<? super Object, ? extends Long>)SnTemplate::getTemplateId, (Function<? super Object, ? extends SnTemplate>)Function.identity()));
        final List<SnServerTemplateDto> outs = (List<SnServerTemplateDto>)BeanUtils.copyList((List)list, (Class)SnServerTemplateDto.class).stream().peek(obj -> {
            final SnTemplate tp = tempMap.get(obj.getTemplateId());
            if (tp != null) {
                obj.setCategory(tp.getCategory());
                obj.setTemplateName(tp.getName());
                obj.setCountry(tp.getCountry());
                obj.setLanguage(tp.getLanguage());
            }
            return;
        }).collect(Collectors.toList());
        return AjaxResult.success("获取成功", (Object)outs);
    }
    
    @GetMapping({ "/clientVersion" })
    public AjaxResult clientVersion(@RequestParam("code") final String code) {
        final Pair<AjaxResult, SnServer> pair = this.validServer(code);
        if (pair.getLeft() != null) {
            return pair.getLeft();
        }
        final SnServer server = pair.getRight();
        final JSONObject data = new JSONObject();
        data.put((Object)"client", (Object)server.getVersion());
        data.put((Object)"clientNew", (Object)this.configService.selectConfigByKey("sync-client-version"));
        data.put((Object)"clientUa", (Object)server.getUaVersion());
        data.put((Object)"clientUaNew", (Object)this.configService.selectConfigByKey("client-ua-version"));
        data.put((Object)"template", (Object)this.snServerTemplateService.haveUpdateDetail(server.getServerId()));
        return AjaxResult.success("获取成功", (Object)data);
    }
    
    private Pair<AjaxResult, SnServer> validServer(final String code) {
        String ip = IpUtils.getIpAddr();
        if (ip.equals("127.0.0.1")) {
            ip = "43.130.6.19";
        }
        final SnServer params = new SnServer();
        params.setIp(ip);
        params.setIsDelete(Integer.valueOf(0));
        final List<SnServer> servers = this.snServerMapper.selectSnServerList(params);
        if (servers.isEmpty()) {
            return Pair.of(this.error("该服务器IP未获得授权"), (SnServer)null);
        }
        final SnServer server = servers.get(0);
        if (server.getStatus() != 2) {
            return Pair.of(this.error("该服务器状态异常"), server);
        }
        final SysUser user = this.sysUserService.selectUserById(server.getCreateId());
        if (!Objects.equals(user.getLicense(), code)) {
            return Pair.of(this.error("授权码有误"), server);
        }
        if (user.getPeriod().before(new Date())) {
            return Pair.of(this.error("此商户已超过使用期限"), server);
        }
        return Pair.of((AjaxResult)null, server);
    }
}
